//Copyright 2022 JerryLive
//Handles all AI Catapults, not the Player.

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CatapultScript : MonoBehaviour
{

//All occupied Catapults move at the same time and speed.

//The Flyer is located at the start point and headed down the Catapult.
	private Vector3 ZeroPos;

//At the green light:
	//The Carriage and Flyer accelerate.
	private bool catapultBusy;
//When the Carriage reaches the end:
	private const float STOP_DISTANCE = 1.8f;
	//The Carriage stops.
	//The Flyer continues at minimum speed.
//When the Flyer is clear of the Cage:
	private const float CLEAR_DISTANCE = 3f;

//References.
	public FlyerScript FS;
	private int myIndex;		//into Global.Flyer[]


//Start here.################################################
	private void Awake()
	{
		catapultBusy = false;
	}

//GameMaster has removed the Start Canvas.
	public void SetupCatapult()
	{
	}

//GameMaster has set the Green Light.
	public void StartCatapult()
	{
		myIndex = FS.myIndex;
		ZeroPos = transform.position;
		catapultBusy = true;
	}

//Every Physics Frame.
	private void FixedUpdate()
	{
		if (! catapultBusy)
			return;
	//The Flyer and Carriage are catapulting.
		float distance = Vector3.Distance(ZeroPos, transform.position);
		if (distance < STOP_DISTANCE)
		{
			Global.Flyer[myIndex].RB2.AddRelativeForce(new Vector3(Global.CATAPULT_FORCE, 0f, 0f));
			Global.Flyer[myIndex].Carriage.transform.position = Global.Flyer[myIndex].GO.transform.position;
		}
	//Reached the Catapult end.
	//Flyer just keeps going, Carriage stops.
		else if (distance < CLEAR_DISTANCE)
			Global.Flyer[myIndex].RB2.AddRelativeForce(new Vector3(Global.CATAPULT_FORCE, 0f, 0f));
	//Clear of CageCollider.
	//Catapult is all done, enable PLayer and AI to control the Flyers.
		else
			catapultBusy = false;
	}

}
