//Copyright 2022 JerryLive
//Handles a Missle.

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MissleScript : MonoBehaviour
{
//A missle is a circle sprite with a Rigidbody2D and a CircleCollider2D.
//It is fired from the nose of a Flyer with an impulse force.
//If the Flyer is rotating, that applies a lateral impulse force.

//When the missle reaches Global.MISSLE_KILL_DISTANCE from StartPosition, it is killed.
	private Vector3 StartPosition;
//If it hits something first, make a little explosion and die.
	private GameObject Hit;

//References.
	private Rigidbody2D RB2;
	private AudioScript AS;


//Start here.###################################################################
//The missle has been instantiated.
	private void Awake()
	{
		RB2 = GetComponent<Rigidbody2D>();
		AS = FindObjectOfType<AudioScript>();
	}

//Set the StartPosition when the Missle is fired.
	public void SetStartPosition(Vector3 pos)
	{
		StartPosition = pos;
	}

//Any collision has a little explosion.
	private void OnCollisionEnter2D(Collision2D collision)
	{
		if (collision.collider.name == "Cage")
			return;
		Hit = Global.GetHit(collision.collider.bounds.center);
		ParticleSystem PS = Hit.GetComponent<ParticleSystem>();
		PS.Play();
		AS.PlayHit();
		this.gameObject.SetActive(false);
		Invoke("KillHit", 0.5f);
	}
	private void KillHit()
	{
		Hit.SetActive(false);
	}

//Physics update.
	private void FixedUpdate()
	{
		if (Global.DoNotRun)
			return;
		if (Vector3.Distance(StartPosition, transform.position) > Global.MISSLE_KILL_DISTANCE)
			this.gameObject.SetActive(false);
	}

}
